from typing import Any

import typer
from incorta_cloud_client.exceptions import UnauthorizedException, ApiException

from incorta_cloud.expection_handlers.handlers import AbstractHandler
from incorta_cloud.utils import logger


class UnauthorizedExceptionHandler(AbstractHandler):
    def handle(self, app: typer.Typer, e: UnauthorizedException) -> Any:
        logger.error("Token Expired. Sign in again in order to continue the execution of the command")
        success = app(args=["auth", "signin"], standalone_mode=False)
        return success
