from incorta_cloud_client.model.forms_start_upload import FormsStartUpload
from incorta_cloud_client.model.models_upload_metadata import ModelsUploadMetadata

from incorta_cloud.utils.file_utils import FileMetadata


class Adapter:

    @staticmethod
    def file_metadata_to_forms_start_upload(file_metadata: FileMetadata) -> FormsStartUpload:
        return FormsStartUpload(
            name=file_metadata.name,
            path=file_metadata.path,
            cluster_id=file_metadata.cluster_id,
            md5_hash=file_metadata.md5_hash,
            size=file_metadata.size,
            tenant=file_metadata.tenant,
            created_at = file_metadata.created_at,
            updated_at = file_metadata.updated_at
        )

    @staticmethod
    def file_metadata_to_models_metadata(file_metadata: FileMetadata) -> ModelsUploadMetadata:
        return ModelsUploadMetadata(
            cluster_id=file_metadata.cluster_id,
            md5_hash=file_metadata.md5_hash,
            name=file_metadata.name,
            path=file_metadata.path,
            size=file_metadata.size,
            created_at=file_metadata.created_at,
            updated_at=file_metadata.updated_at
        )
