import threading
import time
from typing import Generator


class ConcurrencyManager:
    @staticmethod
    def execute_in_parallel(thread_generator: Generator[threading.Thread, None, None], parallel_uploads: int, block_on_completion: bool = True):
        threads = []
        while True:
            active_threads = threading.active_count()

            # at this point the app has already bootstrapped 2 threads the main and the render for the console.
            if active_threads < parallel_uploads + 3:
                try:
                    thread = next(thread_generator)
                    threads.append(thread)
                except StopIteration:
                    break
                thread.start()

            else:
                time.sleep(1)

        if block_on_completion:
            for t in threads:
                t.join()
