import typing


def parse_name(path: str, name: typing.Union[str, None]) -> typing.Tuple[str, str]:
    if name is None or len(name) is 0:
        parts = path.split('/')
        name = parts[-1]
        path = '/'.join(parts[:-1])

    return path, name


def remove_leading_slash(text: str):
    return text if len(text) > 0 and text[0] != '/' else text[1:]


def remove_trailing_slash(text: str):
    return text if len(text) > 0 and  text[-1] != '/' else text[:-1]


def remove_leading_trailing_slash(text: str):
    return remove_leading_slash(remove_trailing_slash(text))
